/*
	Copyright (c) Microsoft Corporation.  All rights reserved.
*/

#include "sdv_prefixer.h"


#define FILE_AUTOGENERATED_DEVICE_NAME  128
#define FILE_DEVICE_DISK_FILE_SYSTEM    8
#define FILE_DEVICE_NETWORK_FILE_SYSTEM 20
#define FILE_DEVICE_SECURE_OPEN         256
#define FILE_DEVICE_TAPE_FILE_SYSTEM    32

#define IRP_MJ_CREATE 0
#define IRP_MJ_CREATE_NAMED_PIPE 1
#define IRP_MJ_CLOSE 2
#define IRP_MJ_READ 3
#define IRP_MJ_WRITE 4
#define IRP_MJ_DEVICE_CONTROL 14
#define IRP_MJ_INTERNAL_DEVICE_CONTROL 15
#define IRP_MJ_POWER 22


#define IRP_MN_REMOVE_DEVICE 2
#define IRP_MN_START_DEVICE 0
#define IRP_MN_SURPRISE_REMOVAL 23

#define IRP_MN_CANCEL_STOP_DEVICE 6
#define IRP_MN_CANCEL_REMOVE_DEVICE 3


#define IRP_MN_QUERY_STOP_DEVICE 5
#define IRP_MN_QUERY_REMOVE_DEVICE 1
#define IRP_MN_QUERY_DEVICE_RELATIONS 7
#define IRP_MN_QUERY_INTERFACE 8
#define IRP_MN_QUERY_CAPABILITIES 9
#define IRP_MN_QUERY_RESOURCES 10
#define IRP_MN_QUERY_RESOURCE_REQUIREMENTS 11
#define IRP_MN_QUERY_DEVICE_TEXT 12
#define IRP_MN_QUERY_ID 19
#define IRP_MN_QUERY_PNP_DEVICE_STATE 20
#define IRP_MN_QUERY_BUS_INFORMATION 21
#define IRP_MN_QUERY_LEGACY_BUS_INFORMATION 24

#define IO_TYPE_ADAPTER                 1
#define IO_TYPE_CONTROLLER              2
#define IO_TYPE_DEVICE                  3
#define IO_TYPE_DRIVER                  4
#define IO_TYPE_FILE                    5
#define IO_TYPE_IRP                     6
#define IO_TYPE_MASTER_ADAPTER          7
#define IO_TYPE_OPEN_PACKET             8
#define IO_TYPE_TIMER                   9
#define IO_TYPE_VPB                     10
#define IO_TYPE_ERROR_LOG               11
#define IO_TYPE_ERROR_MESSAGE           12
#define IO_TYPE_DEVICE_OBJECT_EXTENSION 13

#define NT_SUCCESS(Status) (Status >= 0)
#define NULL 0

#define PowerDeviceD3 4
#define PowerDeviceD2 3
#define PowerDeviceD1 2
#define PowerDeviceD0 1

#define STATUS_NOT_SUPPORTED 3221225659
#define STATUS_PENDING 259
#define STATUS_SUCCESS 0

#define IRP_MJ_PNP 27

#define WMIREG_ACTION_REGISTER      1
#define WMIREG_ACTION_DEREGISTER    2

#define KernelMode 0
#define UserMode 1
#define MaximumMode 2

#define BusRelations 0
#define EjectionRelations 1
#define PowerRelations 2
#define RemovalRelations 3
#define TargetDeviceRelation 4
#define SingleBusRelations 5


#define NonPagedPool 0
#define PagedPool 1
#define NonPagedPoolMustSucceed 2
#define DontUseThisType 3
#define NonPagedPoolCacheAligned 4
#define PagedPoolCacheAligned 5
#define NonPagedPoolCacheAlignedMustS 6


#define OBJ_KERNEL_HANDLE 512


#define PASSIVE_LEVEL 0 
#define APC_LEVEL 1 
#define DISPATCH_LEVEL 2 


#define DIRQL(irql) ((irql)!=PASSIVE_LEVEL && (irql)!=APC_LEVEL && (irql)!=DISPATCH_LEVEL)

#define STACKL Tail.Overlay.CurrentStackLocation
