/**********************************************************************
 * 
 *  Toby Opferman
 *
 *  Driver Example
 *
 *  This example is for educational purposes only.  I license this source
 *  out for use in learning how to write a device driver.
 *
 *     Driver Shared Header File
 **********************************************************************/




#ifndef __EXAMPLE_H__
#define __EXAMPLE_H__

typedef unsigned int UINT;
typedef char * PCHAR;

 #define __USE_DIRECT__ 
/* #define __USE_BUFFERED__ */

//added per PREfast
DRIVER_DISPATCH Eightball_Create;
DRIVER_DISPATCH Eightball_Close;
DRIVER_DISPATCH Eightball_IoControl;
DRIVER_DISPATCH Eightball_ReadDirectIO;
DRIVER_DISPATCH Eightball_WriteBufferedIO;
DRIVER_DISPATCH Eightball_WriteDirectIO;
DRIVER_DISPATCH Eightball_WriteNeither;
DRIVER_DISPATCH Eightball_UnSupportedFunction;
//end of PREfast suggested additions


NTSTATUS Eightball_Create(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS Eightball_Close(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS Eightball_IoControl(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS Eightball_ReadDirectIO(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS Eightball_WriteBufferedIO(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS Eightball_WriteDirectIO(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS Eightball_WriteNeither(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS Eightball_UnSupportedFunction(PDEVICE_OBJECT DeviceObject, PIRP Irp);

#ifdef __USE_DIRECT__
#define IO_TYPE DO_DIRECT_IO
#define USE_WRITE_FUNCTION  Eightball_WriteDirectIO
#define USE_READ_FUNCTION   Eightball_ReadDirectIO
#endif
 
#ifdef __USE_BUFFERED__
#define IO_TYPE DO_BUFFERED_IO
#define USE_WRITE_FUNCTION  Eightball_WriteBufferedIO
#define USE_READ_FUNCTION   Eightball_ReadBufferedIO
#endif

#ifndef IO_TYPE
#define IO_TYPE 0
#define USE_WRITE_FUNCTION  Eightball_WriteNeither
#define USE_READ_FUNCTION   Eightball_ReadNeither
#endif

#endif









